Index: uspace/srv/ns/service.c
===================================================================
--- uspace/srv/ns/service.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/ns/service.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -40,29 +40,37 @@
 #include "ns.h"
 
-
 /** Service hash table item. */
 typedef struct {
 	ht_link_t link;
-	sysarg_t service;        /**< Service ID. */
-	sysarg_t phone;          /**< Phone registered with the service. */
-	sysarg_t in_phone_hash;  /**< Incoming phone hash. */
+	
+	/** Service ID */
+	service_t service;
+	
+	/** Phone registered with the interface */
+	sysarg_t phone;
+	
+	/** Incoming phone hash */
+	sysarg_t in_phone_hash;
 } hashed_service_t;
 
-
 static size_t service_key_hash(void *key)
 {
-	return *(sysarg_t*)key;
+	return *(service_t *) key;
 }
 
 static size_t service_hash(const ht_link_t *item)
 {
-	hashed_service_t *hs = hash_table_get_inst(item, hashed_service_t, link);
-	return hs->service;
+	hashed_service_t *service =
+	    hash_table_get_inst(item, hashed_service_t, link);
+	
+	return service->service;
 }
 
 static bool service_key_equal(void *key, const ht_link_t *item)
 {
-	hashed_service_t *hs = hash_table_get_inst(item, hashed_service_t, link);
-	return hs->service == *(sysarg_t*)key;
+	hashed_service_t *service =
+	    hash_table_get_inst(item, hashed_service_t, link);
+	
+	return service->service == *(service_t *) key;
 }
 
@@ -82,8 +90,8 @@
 typedef struct {
 	link_t link;
-	sysarg_t service;        /**< Number of the service. */
-	ipc_callid_t callid;     /**< Call ID waiting for the connection */
-	sysarg_t arg2;           /**< Second argument */
-	sysarg_t arg3;           /**< Third argument */
+	service_t service;    /**< Service ID */
+	iface_t iface;        /**< Interface ID */
+	ipc_callid_t callid;  /**< Call ID waiting for the connection */
+	sysarg_t arg3;        /**< Third argument */
 } pending_conn_t;
 
@@ -92,6 +100,7 @@
 int service_init(void)
 {
-	if (!hash_table_create(&service_hash_table, 0, 0, &service_hash_table_ops)) {
-		printf(NAME ": No memory available for services\n");
+	if (!hash_table_create(&service_hash_table, 0, 0,
+	    &service_hash_table_ops)) {
+		printf("%s: No memory available for services\n", NAME);
 		return ENOMEM;
 	}
@@ -106,15 +115,16 @@
 {
 loop:
-	list_foreach(pending_conn, link, pending_conn_t, pr) {
-		ht_link_t *link = hash_table_find(&service_hash_table, &pr->service);
+	list_foreach(pending_conn, link, pending_conn_t, pending) {
+		ht_link_t *link = hash_table_find(&service_hash_table, &pending->service);
 		if (!link)
 			continue;
 		
-		hashed_service_t *hs = hash_table_get_inst(link, hashed_service_t, link);
-		(void) ipc_forward_fast(pr->callid, hs->phone, pr->arg2,
-		    pr->arg3, 0, IPC_FF_NONE);
-		
-		list_remove(&pr->link);
-		free(pr);
+		hashed_service_t *hashed_service = hash_table_get_inst(link, hashed_service_t, link);
+		(void) ipc_forward_fast(pending->callid, hashed_service->phone,
+		    pending->iface, pending->arg3, 0, IPC_FF_NONE);
+		
+		list_remove(&pending->link);
+		free(pending);
+		
 		goto loop;
 	}
@@ -130,17 +140,19 @@
  *
  */
-int register_service(sysarg_t service, sysarg_t phone, ipc_call_t *call)
+int register_service(service_t service, sysarg_t phone, ipc_call_t *call)
 {
 	if (hash_table_find(&service_hash_table, &service))
-		return EEXISTS;
-	
-	hashed_service_t *hs = (hashed_service_t *) malloc(sizeof(hashed_service_t));
-	if (!hs)
+		return EEXIST;
+	
+	hashed_service_t *hashed_service =
+	    (hashed_service_t *) malloc(sizeof(hashed_service_t));
+	if (!hashed_service)
 		return ENOMEM;
 	
-	hs->service = service;
-	hs->phone = phone;
-	hs->in_phone_hash = call->in_phone_hash;
-	hash_table_insert(&service_hash_table, &hs->link);
+	hashed_service->service = service;
+	hashed_service->phone = phone;
+	hashed_service->in_phone_hash = call->in_phone_hash;
+	
+	hash_table_insert(&service_hash_table, &hashed_service->link);
 	
 	return EOK;
@@ -150,4 +162,5 @@
  *
  * @param service Service to be connected to.
+ * @param iface   Interface to be connected to.
  * @param call    Pointer to call structure.
  * @param callid  Call ID of the request.
@@ -156,34 +169,39 @@
  *
  */
-void connect_to_service(sysarg_t service, ipc_call_t *call, ipc_callid_t callid)
-{
+void connect_to_service(service_t service, iface_t iface, ipc_call_t *call,
+    ipc_callid_t callid)
+{
+	sysarg_t arg3 = IPC_GET_ARG3(*call);
+	sysarg_t flags = IPC_GET_ARG4(*call);
 	sysarg_t retval;
 	
 	ht_link_t *link = hash_table_find(&service_hash_table, &service);
 	if (!link) {
-		if (IPC_GET_ARG4(*call) & IPC_FLAG_BLOCKING) {
+		if (flags & IPC_FLAG_BLOCKING) {
 			/* Blocking connection, add to pending list */
-			pending_conn_t *pr =
+			pending_conn_t *pending =
 			    (pending_conn_t *) malloc(sizeof(pending_conn_t));
-			if (!pr) {
+			if (!pending) {
 				retval = ENOMEM;
 				goto out;
 			}
 			
-			link_initialize(&pr->link);
-			pr->service = service;
-			pr->callid = callid;
-			pr->arg2 = IPC_GET_ARG2(*call);
-			pr->arg3 = IPC_GET_ARG3(*call);
-			list_append(&pr->link, &pending_conn);
+			link_initialize(&pending->link);
+			pending->service = service;
+			pending->iface = iface;
+			pending->callid = callid;
+			pending->arg3 = arg3;
+			
+			list_append(&pending->link, &pending_conn);
 			return;
 		}
+		
 		retval = ENOENT;
 		goto out;
 	}
 	
-	hashed_service_t *hs = hash_table_get_inst(link, hashed_service_t, link);
-	(void) ipc_forward_fast(callid, hs->phone, IPC_GET_ARG2(*call),
-	    IPC_GET_ARG3(*call), 0, IPC_FF_NONE);
+	hashed_service_t *hashed_service = hash_table_get_inst(link, hashed_service_t, link);
+	(void) ipc_forward_fast(callid, hashed_service->phone, iface, arg3,
+	    0, IPC_FF_NONE);
 	return;
 	
Index: uspace/srv/ns/service.h
===================================================================
--- uspace/srv/ns/service.h	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/ns/service.h	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -36,10 +36,12 @@
 #include <sys/types.h>
 #include <ipc/common.h>
+#include <ipc/services.h>
+#include <abi/ipc/interfaces.h>
 
 extern int service_init(void);
 extern void process_pending_conn(void);
 
-extern int register_service(sysarg_t, sysarg_t, ipc_call_t *);
-extern void connect_to_service(sysarg_t, ipc_call_t *, ipc_callid_t);
+extern int register_service(service_t, sysarg_t, ipc_call_t *);
+extern void connect_to_service(service_t, iface_t, ipc_call_t *, ipc_callid_t);
 
 #endif
Index: uspace/srv/ns/task.c
===================================================================
--- uspace/srv/ns/task.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/ns/task.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -231,10 +231,9 @@
 int ns_task_id_intro(ipc_call_t *call)
 {
-	
 	task_id_t id = MERGE_LOUP32(IPC_GET_ARG1(*call), IPC_GET_ARG2(*call));
-
+	
 	ht_link_t *link = hash_table_find(&phone_to_id, &call->in_phone_hash);
 	if (link != NULL)
-		return EEXISTS;
+		return EEXIST;
 	
 	p2i_entry_t *entry = (p2i_entry_t *) malloc(sizeof(p2i_entry_t));
Index: uspace/srv/taskmon/taskmon.c
===================================================================
--- uspace/srv/taskmon/taskmon.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/taskmon/taskmon.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -147,5 +147,5 @@
 	}
 	
-	async_set_client_connection(corecfg_client_conn);
+	async_set_fallback_port_handler(corecfg_client_conn, NULL);
 	
 	int rc = loc_server_register(NAME);
Index: uspace/srv/vfs/vfs.c
===================================================================
--- uspace/srv/vfs/vfs.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/vfs/vfs.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -74,8 +74,8 @@
 			break;
 		case VFS_IN_MOUNT:
-			vfs_mount(callid, &call);
+			vfs_mount_srv(callid, &call);
 			break;
 		case VFS_IN_UNMOUNT:
-			vfs_unmount(callid, &call);
+			vfs_unmount_srv(callid, &call);
 			break;
 		case VFS_IN_OPEN:
@@ -181,5 +181,5 @@
 	 * Set a connection handling function/fibril.
 	 */
-	async_set_client_connection(vfs_connection);
+	async_set_fallback_port_handler(vfs_connection, NULL);
 
 	/*
Index: uspace/srv/vfs/vfs.h
===================================================================
--- uspace/srv/vfs/vfs.h	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/vfs/vfs.h	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -205,6 +205,6 @@
 
 extern void vfs_register(ipc_callid_t, ipc_call_t *);
-extern void vfs_mount(ipc_callid_t, ipc_call_t *);
-extern void vfs_unmount(ipc_callid_t, ipc_call_t *);
+extern void vfs_mount_srv(ipc_callid_t, ipc_call_t *);
+extern void vfs_unmount_srv(ipc_callid_t, ipc_call_t *);
 extern void vfs_open(ipc_callid_t, ipc_call_t *);
 extern void vfs_sync(ipc_callid_t, ipc_call_t *);
Index: uspace/srv/vfs/vfs_ops.c
===================================================================
--- uspace/srv/vfs/vfs_ops.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/vfs/vfs_ops.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -266,5 +266,5 @@
 }
 
-void vfs_mount(ipc_callid_t rid, ipc_call_t *request)
+void vfs_mount_srv(ipc_callid_t rid, ipc_call_t *request)
 {
 	service_id_t service_id;
@@ -405,5 +405,5 @@
 }
 
-void vfs_unmount(ipc_callid_t rid, ipc_call_t *request)
+void vfs_unmount_srv(ipc_callid_t rid, ipc_call_t *request)
 {
 	int rc;
Index: uspace/srv/vfs/vfs_register.c
===================================================================
--- uspace/srv/vfs/vfs_register.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/vfs/vfs_register.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -113,5 +113,5 @@
 void vfs_register(ipc_callid_t rid, ipc_call_t *request)
 {
-	dprintf("Processing VFS_REGISTER request received from %p.\n",
+	dprintf("Processing VFS_REGISTER request received from %zx.\n",
 	    request->in_phone_hash);
 	
@@ -162,5 +162,5 @@
 		fibril_mutex_unlock(&fs_list_lock);
 		free(fs_info);
-		async_answer_0(rid, EEXISTS);
+		async_answer_0(rid, EEXIST);
 		return;
 	}
@@ -196,5 +196,5 @@
 	ipc_callid_t callid;
 	if (!async_share_in_receive(&callid, &size)) {
-		dprintf("Unexpected call, method = %d\n", IPC_GET_IMETHOD(call));
+		dprintf("Unexpected call\n");
 		list_remove(&fs_info->fs_link);
 		fibril_mutex_unlock(&fs_list_lock);
@@ -210,5 +210,5 @@
 	 */
 	if (size != PLB_SIZE) {
-		dprintf("Client suggests wrong size of PFB, size = %d\n", size);
+		dprintf("Client suggests wrong size of PFB, size = %zu\n", size);
 		list_remove(&fs_info->fs_link);
 		fibril_mutex_unlock(&fs_list_lock);
Index: uspace/srv/volsrv/empty.c
===================================================================
--- uspace/srv/volsrv/empty.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/volsrv/empty.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -96,5 +96,5 @@
 	bool empty;
 
-	rc = block_init(EXCHANGE_SERIALIZE, sid, 2048);
+	rc = block_init(sid, 2048);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Error opening "
@@ -186,5 +186,5 @@
 	size_t block_size;
 
-	rc = block_init(EXCHANGE_SERIALIZE, sid, 2048);
+	rc = block_init(sid, 2048);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Error opening "
Index: uspace/srv/volsrv/volsrv.c
===================================================================
--- uspace/srv/volsrv/volsrv.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/volsrv/volsrv.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -65,5 +65,5 @@
 		return rc;
 
-	async_set_client_connection(vol_client_conn);
+	async_set_fallback_port_handler(vol_client_conn, NULL);
 
 	rc = loc_server_register(NAME);
